CC****************************************************************
      PROGRAM stan2 
CC  mapa standard y su mapa tangente
CC****************************************************************
      IMPLICIT REAL*8(a-h,o-z)
      OPEN(21,FILE='stan2.dat')
      READ(21,*)xk
      READ(21,*)N,icada
      READ(21,*)s,t
      CLOSE(21)
      OPEN(31,FILE='stan2.out')
      dospi=8.d0*DATAN(1.d0)
      xk1=xk/dospi
      delta0=1.d-9
      eta=delta0
      xi=delta0
      DO 4 i=1,N
      zi=i
      se=DSIN(dospi*t)
      co=DCOS(dospi*t)
      s=s+xk1*se
      t=t+s
      eta=eta+dospi*xk1*co*xi
      xi=xi+eta
       t=DMOD(t,1.d0)
       IF (t.lt.0.d0) t=t+1.d0
        s=DMOD(s,1.d0) 
       IF(s.LT.0.d0)s=s+1.d0 
       delta=dsqrt(xi**2+eta**2)
       xly=dlog(delta/delta0)/zi
      IF (MOD(i,icada).eq.0) WRITE(31,*)i,delta,xly
    4 CONTINUE
      END

